<?php
// +----------------------------------------------------------------------
// | 简美blog [ 自媒体社交建站系统 ]
// +----------------------------------------------------------------------
// | Copyright (c) 2016 http://www.jmblog.cn All rights reserved.
// +----------------------------------------------------------------------
// | Author: Dreams <337662168@qq.com> <http://www.jmblog.cn>
// +----------------------------------------------------------------------
namespace Addons\Label;
use Common\Controller\Addon;

/**
 * 自定义标签插件
 * @ Author: Dreams <337662168@qq.com> <http://www.jmblog.cn>
 */

    class LabelAddon extends Addon{

        public $info = array(
            'name'=>'Label',
            'title'=>'标签插件',
            'description'=>'关联模型标签插件',
            'status'=>1,
            'author'=>'Dreams',
            'version'=>'1.0'
        );

        public function install(){

            /* 先判断插件需要的钩子是否存在 */
            $this->getisHook('Label', $this->info['name'], $this->info['description']);

            //读取插件sql文件
            $sqldata = file_get_contents('http://'.$_SERVER['HTTP_HOST'].__ROOT__.'/Addons/'.$this->info['name'].'/install.sql');
            $sqlFormat = $this->sql_split($sqldata, C('DB_PREFIX'));
            $counts = count($sqlFormat);
            
            for ($i = 0; $i < $counts; $i++) {
                $sql = trim($sqlFormat[$i]);
                D()->execute($sql);
            }
            return true;
        }

        public function uninstall(){
            //读取插件sql文件
            $sqldata = file_get_contents('http://'.$_SERVER['HTTP_HOST'].__ROOT__.'/Addons/'.$this->info['name'].'/uninstall.sql');
            $sqlFormat = $this->sql_split($sqldata, C('DB_PREFIX'));
            $counts = count($sqlFormat);
             
            for ($i = 0; $i < $counts; $i++) {
                $sql = trim($sqlFormat[$i]);
                D()->execute($sql);
            }
            return true;
        }

		//实现的Label钩子方法
        public function Label($param){
			$Label=M('Label');
			$map['_string']='FIND_IN_SET("'.$param['model_id'].'", m_id)';
			$map['recommend']=1;
			//获取常用Label标签
			$Labellist=$Label->where($map)->limit(15)->select();
			
			//获取当前所属Label标签
			if(!empty($param['value'])){
				$maps['id'] = array('in',array_filter(explode(',',$param['value'])));
				$listLabel=$Label->where($maps)->select();
				$this->assign('listLabel',  $listLabel);
			}
			$this->assign('Labellist',  $Labellist);
            $this->assign('param', $param);
            $this->display('label');
        }

        //获取插件所需的钩子是否存在
        public function getisHook($str, $addons, $msg=''){
            $hook_mod = M('Hooks');
            $where['name'] = $str;
            $gethook = $hook_mod->where($where)->find();
            if(!$gethook || empty($gethook) || !is_array($gethook)){
                $data['name'] = $str;
                $data['description'] = $msg;
                $data['type'] = 1;
                $data['update_time'] = NOW_TIME;
                $data['addons'] = $addons;
                if( false !== $hook_mod->create($data) ){
                    $hook_mod->add();
                }
            }
        }

        /**
         * 解析数据库语句函数
         * @param string $sql  sql语句   带默认前缀的
         * @param string $tablepre  自己的前缀
         * @return multitype:string 返回最终需要的sql语句
         */
        public function sql_split($sql, $tablepre) {

            if ($tablepre != "onethink_")
                $sql = str_replace("onethink_", $tablepre, $sql);
                $sql = preg_replace("/TYPE=(InnoDB|MyISAM|MEMORY)( DEFAULT CHARSET=[^; ]+)?/", "ENGINE=\\1 DEFAULT CHARSET=utf8", $sql);

            if ($r_tablepre != $s_tablepre)
                $sql = str_replace($s_tablepre, $r_tablepre, $sql);
                $sql = str_replace("\r", "\n", $sql);
                $ret = array();

                $num = 0;
                $queriesarray = explode(";\n", trim($sql));
                unset($sql);

            foreach ($queriesarray as $query) {
                $ret[$num] = '';
                $queries = explode("\n", trim($query));
                $queries = array_filter($queries);
                foreach ($queries as $query) {
                    $str1 = substr($query, 0, 1);
                    if ($str1 != '#' && $str1 != '-')
                        $ret[$num] .= $query;
                }
                $num++;
            }
            return $ret;
        }

    }